// PC - Native Code Functions

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "memory.h"

#include "Memory1.h"
#include "custom.h"

#include "readcpu.h"
#include "newcpu.h"
#include "debug.h"

#include "Native.h"
#include "Sony.h"

#include "reentrant_newcpu.h"

#include "win32\win32port.h"

typedef long		_Size;
typedef long		_Ptr;
typedef long		_ResType;

void method_doClipboardDump(long length, _ResType theType, _Ptr source);
int isEqual_String_ResType(char *string_aga_zing, _ResType ResType);
unsigned long fix_endian_long(unsigned long da_long);

static int Installed = 0;

unsigned long iteration_count = 0;

void Install_Patch (void)
{
  return;
}

int  Check_Patch (void)
{
  if (Check_Sony_Patch() == 1) // Check if we want to transparently patch
    return 1;

  return 0; // Not a transparent patch
}

int  Check_Illegal (void)
{
  #ifdef _Sony_Enabled
  if (Check_Sony_Illegal() == 1) // Check if a Sony call
    return 1;
  #endif
  return 0; // Not handled, do Illegal
}

//
// Bill Huey comment ---
//
// A "call" is an "A"-line trap that requires
// parameters passed by a mc68000 LINK instruction...
// Wrong...
//
// What the hell is the philosophy of this function ???
//
// It looks as if it tries to executes through the A-line
// trap by single the emulator until encounters a 68k RTE
// (Return from Exception) instruction, which is detected
// by seeing if the m689k program counter points to the
// instruction just after the A-line trap...
//

void Call_ATrap (UWORD ATrap_instruction_word)
{
CPTR	ATrap_termination_program_counter,
	VM_instruction_word_address;

UWORD actual_instruction_word,
	*real_overridden_instruction_word_address;

unsigned long	instruction_count;

//
// Points to the instruction word fragment or "opcode"
// that immediately follows a clean A-line trap
// single step execution.
//

	ATrap_termination_program_counter = m68k_getpc() + 2;

//
// Bill Huey ---
// screwed up type casting problems...
//
// bill huey ---
// Fri Sep 26 17:26:19 PDT 1997
//
// I didn't know this until now, but the use of direct pointers
// to write into vMac's virtual machine memory allows writes into
// memory that would normally be write protected, such as
// Macintosh ROM memory...
//
// Altering instruction word stream in protected memory is essential
// for this function to work correctly...
//

ROMmem_write_enable_set(on);

	VM_instruction_word_address = m68k_getpc();

	actual_instruction_word	= get_word(VM_instruction_word_address);
	put_word(VM_instruction_word_address, ATrap_instruction_word);

	// This sets up the exception stack frame...
	Exception(0x0A, 0);

	instruction_count=0;

	iteration_count++;

	// Basically this block iterates until the A-Line Trap is finished ...
	do
	{
		instruction_count++;

		reentrant_m68k_step();
	} while (ATrap_termination_program_counter != m68k_getpc());

	put_word(VM_instruction_word_address, actual_instruction_word);

	m68k_setpc(ATrap_termination_program_counter - 2);

/* Michael - Set to 'off' */

ROMmem_write_enable_set(off);

}

// bill comment ---
//
void Run_ATrap (void)
{
CPTR NextPC = 0;

	NextPC = m68k_getpc() + 2;

	Exception(0x0A, 0);
	do
	{
		reentrant_m68k_step();
	} while (NextPC != m68k_getpc());

}

void _Native_PutScrap()
{
long	length;
_ResType theType;
_Ptr	source;
//
// Only the procedure parameters are on the stack...
// The return address isn't because an A-Trap exeception
// had yet to be generated...
//
	length  = get_long(m68k_areg(regs, 7) + 8);
	theType = get_long(m68k_areg(regs, 7) + 4);
	source  = get_long(m68k_areg(regs, 7) + 0);
	Run_ATrap();
	method_doClipboardDump(length, theType, source);
}

//
// Override this function to add specific Clipboard functionality
// for each vMac port...
//
// This will not handle private application scraps...
//
// The Macintosh uses '\r' while Unix uses '\n' for the return character
// respectively...
//
void method_doClipboardDump(long length, _ResType theType, _Ptr source)
{
    int loop;
    char blahblah;
    FILE * OutFile;

	if(isEqual_String_ResType("TEXT", theType))
	{
        char TxtFile[1024];

        strcpy(TxtFile,vMacPath);
        strcpy(&TxtFile[strlen(TxtFile)], "\\Clipboard.txt");

        OutFile=fopen(TxtFile,"w+");
        if(OutFile==NULL)
            return;

		for(loop = 0; loop < length; ++loop)
		{
			blahblah = get_byte(source + loop);
            if (blahblah == 13)
				fprintf(OutFile,"\n");
		    else
    			fprintf(OutFile,"%c",blahblah);
		}

		fclose(OutFile);
	}
    else
	{
	    char ClipFile[1024];

        strcpy(ClipFile,vMacPath);
        strcpy(&ClipFile[strlen(ClipFile)], "\\Clipboard");

        OutFile=fopen(ClipFile,"wb+");
        if(OutFile==NULL)
            return;

		for(loop = 0; loop < length; ++loop)
		{
		    blahblah=get_byte(source + loop);
            fwrite(&blahblah,1,1,OutFile);
        }

        fclose(OutFile);
	}

    return;
}

//
// Compares the datatype "ResType" with the string
// to see if they are equal...
//
int isEqual_String_ResType(char *string_aga_zing, _ResType ResType)
{
char buffer[10];
int *du = (int *)&buffer;

	*du = fix_endian_long(ResType);
	buffer[4] = '\0';
//	debugout(true, "buffer = %s\n", buffer);
//	debugout(true, "string = %s\n", string_aga_zing);

	if (strcmp(string_aga_zing, buffer) == 0)
		return 1;
	else
		return 0;
}

unsigned long fix_endian_long(unsigned long da_long)
{
	return	(unsigned long)
		 ((da_long >> 24) & 0x000000ff)
		|((da_long >> 8)  & 0x0000ff00)
		|((da_long << 8)  & 0x00ff0000)
		|((da_long & 0x000000ff) << 24);
}
